#include <pwmWrite.h>
#include "esp_camera.h"
#include <WiFi.h>
#include "esp_timer.h"
#include "img_converters.h"
#include "Arduino.h"
#include "fb_gfx.h"
#include "soc/soc.h"             // disable brownout problems
#include "soc/rtc_cntl_reg.h"    // disable brownout problems
#include "esp_http_server.h"

#include "esp_http_server.h"
#include "esp32-hal-ledc.h"
#include "sdkconfig.h"

Pwm pwm = Pwm();

const int servo1 = 6;
const int servo2 = 5;
const int servo3 = 44;
const int servo4 = 7;
const int servo5 = 8;
const int servo6 = 9;

int center1 = 90;     //best center position of each leg (individual)
int center2 = 90;
int center3 = 90;
int center4 = 90;
int center5 = 90;
int center6 = 90;

int pos = 90;
int pos2;
int Min = 50;         //move betwenn this two values
int Max = 100;
int speed1 = 2000;       //pause between forward and backward movement
int steplength = 30;    //big step
int smallstep = 5;      //small step
int flag = 0;
String currentCommand = "stop";


// button * * * * * * * * * * * * * * * * * * * *
const int buttonLeft = 1;
const int buttonRight = 2;
int leftState =0;
int rightState =0;

// camera * * * * * * * * * * * * * * * * * * * *
#include "esp_camera.h"
#include <WiFi.h>
#include "esp_timer.h"
#include "img_converters.h"
#include "Arduino.h"
#include "fb_gfx.h"
#include "soc/soc.h"             // disable brownout problems
#include "soc/rtc_cntl_reg.h"    // disable brownout problems
#include "esp_http_server.h"

#include "esp_http_server.h"
#include "esp32-hal-ledc.h"
#include "sdkconfig.h"

#define CAMERA_MODEL_XIAO_ESP32S3 // Has PSRAM

#if defined(ARDUINO_ARCH_ESP32) && defined(CONFIG_ARDUHAL_ESP_LOG)
#include "esp32-hal-log.h"
#endif

// Replace with your network data
const char* ssid = "Red_Ant_Access";  //or set another name
//const char* password = "xxx";       //set you own password

#define PART_BOUNDARY "123456789000000000000987654321"

#define CAMERA_MODEL_AI_THINKER
//#define CAMERA_MODEL_WROVER_KIT

#if defined(CAMERA_MODEL_XIAO_ESP32S3)
 #define PWDN_GPIO_NUM     -1
 #define RESET_GPIO_NUM    -1
 #define XCLK_GPIO_NUM     10
 #define SIOD_GPIO_NUM     40
 #define SIOC_GPIO_NUM     39

 #define Y9_GPIO_NUM       48
 #define Y8_GPIO_NUM       11
 #define Y7_GPIO_NUM       12
 #define Y6_GPIO_NUM       14
 #define Y5_GPIO_NUM       16
 #define Y4_GPIO_NUM       18
 #define Y3_GPIO_NUM       17
 #define Y2_GPIO_NUM       15
 #define VSYNC_GPIO_NUM    38
 #define HREF_GPIO_NUM     47
 #define PCLK_GPIO_NUM     13

#define LED_GPIO_NUM      21

#else
  #error "Camera model not selected"
#endif


// web page for remote control and screen * * * * * * * * * * * * *
static const char* _STREAM_CONTENT_TYPE = "multipart/x-mixed-replace;boundary=" PART_BOUNDARY;
static const char* _STREAM_BOUNDARY = "\r\n--" PART_BOUNDARY "\r\n";
static const char* _STREAM_PART = "Content-Type: image/jpeg\r\nContent-Length: %u\r\n\r\n";

httpd_handle_t camera_httpd = NULL;
httpd_handle_t stream_httpd = NULL;

static const char PROGMEM INDEX_HTML[] = R"rawliteral(
<html>
  <head>
    <title>Red Ant</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <style>
      body { font-family: Arial; text-align: center; margin:0px auto; padding-top: 30px; background-color: #010101; color: orange;}
      table { margin-left: auto; margin-right: auto; }
      td { padding: 8 px; }
      .button1 {
        background-color: #f93e16;
        border: 1;
        color: white;
        padding: 10px 20px;
        text-align: center;
        text-decoration: none;
        display: inline-block;
        font-size: 32px;
        margin: 6px 3px;
        cursor: pointer;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        -webkit-tap-highlight-color: rgba(0,0,0,0);
      }
      .button2 {
        background-color: #4EB232;
        border: 1;
        color: white;
        padding: 10px 20px;
        text-align: center;
        text-decoration: none;
        display: inline-block;
        font-size: 18px;
        margin: 6px 3px;
        cursor: pointer;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        -webkit-tap-highlight-color: rgba(0,0,0,0);
      }

      img {  width: auto ;
        max-width: 100% ;
        height: auto ;
      }
    </style>
  </head>
  <body>
    <h1>Red Ant</h1>
    <img src="" id="photo">
    

   <table>
     <tr>
     <td align="center"><button1 class="button1" onmousedown="toggleCheckbox('left');" ontouchstart="toggleCheckbox('left');" onmouseup="toggleCheckbox('stop');" ontouchend="toggleCheckbox('stop');">&#8598;</button1></td>
     <td align="center"><button1 class="button1" onmousedown="toggleCheckbox('forward');" ontouchstart="toggleCheckbox('forward');" onmouseup="toggleCheckbox('stop');" ontouchend="toggleCheckbox('stop');">  &#8593; &#8593;  </button1></td>
     <td align="center"><button1 class="button1" onmousedown="toggleCheckbox('right');" ontouchstart="toggleCheckbox('right');" onmouseup="toggleCheckbox('stop');" ontouchend="toggleCheckbox('stop');">&#8599;</button1></td>
     </tr>

      <tr><td align="center"><button1 class="button1" onmousedown="toggleCheckbox('turnleft');" ontouchstart="toggleCheckbox('turnleft');" onmouseup="toggleCheckbox('stop');" ontouchend="toggleCheckbox('stop');">&#8630;</button1></td>
      <td align="center"><button1 class="button1" onmousedown="toggleCheckbox('rise');" ontouchstart="toggleCheckbox('rise');" onmouseup="toggleCheckbox('stop');" ontouchend="toggleCheckbox('stop');">&#x27F0;</button1></td>/
      <td align="center"><button1 class="button1" onmousedown="toggleCheckbox('turnright');" ontouchstart="toggleCheckbox('turnright');" onmouseup="toggleCheckbox('stop');" ontouchend="toggleCheckbox('stop');">&#8631;</button1></td></tr>

      <tr><td colspan="3" align="center"><button1 class="button1" onmousedown="toggleCheckbox('backward');" ontouchstart="toggleCheckbox('backward');" onmouseup="toggleCheckbox('stop');" ontouchend="toggleCheckbox('stop');">&#8595;</button1></td></tr>
      <tr><td colspan="3" align="center"><button2 class="button2" onmousedown="toggleCheckbox('automode');" ontouchstart="toggleCheckbox('automode');" onmouseup="toggleCheckbox('stop');" ontouchend="toggleCheckbox('stop');">Auto Mode</button1></td></tr>
         
    </table>
   <script>
   function toggleCheckbox(x) {
     var xhr = new XMLHttpRequest();
     xhr.open("GET", "/action?go=" + x, true);
     xhr.send();
   }
   window.onload = document.getElementById("photo").src = window.location.href.slice(0, -1) + ":81/stream";
  </script>
  </body>
</html>

)rawliteral";

static esp_err_t index_handler(httpd_req_t *req){
  httpd_resp_set_type(req, "text/html");
  return httpd_resp_send(req, (const char *)INDEX_HTML, strlen(INDEX_HTML));
}

static esp_err_t stream_handler(httpd_req_t *req){
  camera_fb_t * fb = NULL;
  esp_err_t res = ESP_OK;
  size_t _jpg_buf_len = 0;
  uint8_t * _jpg_buf = NULL;
  char * part_buf[64];

  res = httpd_resp_set_type(req, _STREAM_CONTENT_TYPE);
  if(res != ESP_OK){
    return res;
  }

  while(true){
    fb = esp_camera_fb_get();
    if (!fb) {
      Serial.println("Camera capture failed");
      res = ESP_FAIL;
    } else {
      if(fb->width > 400){
        if(fb->format != PIXFORMAT_JPEG){
          bool jpeg_converted = frame2jpg(fb, 80, &_jpg_buf, &_jpg_buf_len);
          esp_camera_fb_return(fb);
          fb = NULL;
          if(!jpeg_converted){
            Serial.println("JPEG compression failed");
            res = ESP_FAIL;
          }
        } else {
          _jpg_buf_len = fb->len;
          _jpg_buf = fb->buf;
        }
      }
    }
    if(res == ESP_OK){
      size_t hlen = snprintf((char *)part_buf, 64, _STREAM_PART, _jpg_buf_len);
      res = httpd_resp_send_chunk(req, (const char *)part_buf, hlen);
    }
    if(res == ESP_OK){
      res = httpd_resp_send_chunk(req, (const char *)_jpg_buf, _jpg_buf_len);
    }
    if(res == ESP_OK){
      res = httpd_resp_send_chunk(req, _STREAM_BOUNDARY, strlen(_STREAM_BOUNDARY));
    }
    if(fb){
      esp_camera_fb_return(fb);
      fb = NULL;
      _jpg_buf = NULL;
    } else if(_jpg_buf){
      free(_jpg_buf);
      _jpg_buf = NULL;
    }
    if(res != ESP_OK){
      break;
    }
    //Serial.printf("MJPG: %uB\n",(uint32_t)(_jpg_buf_len));
  }
  return res;
}

static esp_err_t cmd_handler(httpd_req_t *req){
  char*  buf;
  size_t buf_len;
  char variable[32] = {0,};
 
  buf_len = httpd_req_get_url_query_len(req) + 1;
  if (buf_len > 1) {
    buf = (char*)malloc(buf_len);
    if(!buf){
      httpd_resp_send_500(req);
      return ESP_FAIL;
    }
    if (httpd_req_get_url_query_str(req, buf, buf_len) == ESP_OK) {
      if (httpd_query_key_value(buf, "go", variable, sizeof(variable)) == ESP_OK) {
      } else {
        free(buf);
        httpd_resp_send_404(req);
        return ESP_FAIL;
      }
    } else {
      free(buf);
      httpd_resp_send_404(req);
      return ESP_FAIL;
    }
    free(buf);
  } else {
    httpd_resp_send_404(req);
    return ESP_FAIL;
  }

  sensor_t * s = esp_camera_sensor_get();
  int res = 0;
 
	if(!strcmp(variable, "forward")) {
	  Serial.println("Forward");
	  currentCommand = "forward";
	}
	else if(!strcmp(variable, "left")) {
	  Serial.println("Left");
	  currentCommand = "left";
	}
	else if(!strcmp(variable, "right")) {
	  Serial.println("Right");
	  currentCommand = "right";
	}
	else if(!strcmp(variable, "backward")) {
	  Serial.println("Backward");
	  currentCommand = "backward";
	}
	else if(!strcmp(variable, "turnleft")) {
	  Serial.println("Turn left");
	  currentCommand = "turnleft";
	}
	else if(!strcmp(variable, "turnright")) {
	  Serial.println("Turn right");
	  currentCommand = "turnright";
	}
	else if(!strcmp(variable, "rise")) {
	  Serial.println("Rise");
	  currentCommand = "rise";
	}
	else if(!strcmp(variable, "automode")) {
	  Serial.println("Auto mode toggle");
	  flag = !flag;
	}
	else { // stop
	  Serial.println("Stop");
	  currentCommand = "stop";
	}

  if(res){
    return httpd_resp_send_500(req);
  }

  httpd_resp_set_hdr(req, "Access-Control-Allow-Origin", "*");
  return httpd_resp_send(req, NULL, 0);
}

void startCameraServer(){
  httpd_config_t config = HTTPD_DEFAULT_CONFIG();
  config.server_port = 80;
  httpd_uri_t index_uri = {
    .uri       = "/",
    .method    = HTTP_GET,
    .handler   = index_handler,
    .user_ctx  = NULL
  };

  httpd_uri_t cmd_uri = {
    .uri       = "/action",
    .method    = HTTP_GET,
    .handler   = cmd_handler,
    .user_ctx  = NULL
  };
  httpd_uri_t stream_uri = {
    .uri       = "/stream",
    .method    = HTTP_GET,
    .handler   = stream_handler,
    .user_ctx  = NULL
  };
  if (httpd_start(&camera_httpd, &config) == ESP_OK) {
    httpd_register_uri_handler(camera_httpd, &index_uri);
    httpd_register_uri_handler(camera_httpd, &cmd_uri);
  }
  config.server_port += 1;
  config.ctrl_port += 1;
  if (httpd_start(&stream_httpd, &config) == ESP_OK) {
    httpd_register_uri_handler(stream_httpd, &stream_uri);
  }
}



void setup() {

  WRITE_PERI_REG(RTC_CNTL_BROWN_OUT_REG, 0); //disable brownout detector
 
  Serial.begin(115200);
  Serial.setDebugOutput(false);
 
// button * * * * * * * * * * * * * * * * * *
  pinMode(buttonLeft, INPUT_PULLUP);
  pinMode(buttonRight, INPUT_PULLUP);
  WRITE_PERI_REG(RTC_CNTL_BROWN_OUT_REG, 0); //disable brownout detector
  
  flag=0;

 // servos * * * * * * * * * * * * * * * * * *  
  	pwm.writeServo(servo1, center1);
    delay(20);
	pwm.writeServo(servo2, center2);
    delay(20);
    pwm.writeServo(servo5, center5);
    delay(20);
    pwm.writeServo(servo6, center6);
    delay(20);
	pwm.writeServo(servo3, center3);
    delay(20);
	pwm.writeServo(servo4, center4);
    delay(20);
	
// camera * * * * * * * * * * * * * * * * * *
  camera_config_t config;
  config.ledc_channel = LEDC_CHANNEL_0;
  config.ledc_timer = LEDC_TIMER_0;
  config.pin_d0 = Y2_GPIO_NUM;
  config.pin_d1 = Y3_GPIO_NUM;
  config.pin_d2 = Y4_GPIO_NUM;
  config.pin_d3 = Y5_GPIO_NUM;
  config.pin_d4 = Y6_GPIO_NUM;
  config.pin_d5 = Y7_GPIO_NUM;
  config.pin_d6 = Y8_GPIO_NUM;
  config.pin_d7 = Y9_GPIO_NUM;
  config.pin_xclk = XCLK_GPIO_NUM;
  config.pin_pclk = PCLK_GPIO_NUM;
  config.pin_vsync = VSYNC_GPIO_NUM;
  config.pin_href = HREF_GPIO_NUM;
  config.pin_sscb_sda = SIOD_GPIO_NUM;
  config.pin_sscb_scl = SIOC_GPIO_NUM;
  config.pin_pwdn = PWDN_GPIO_NUM;
  config.pin_reset = RESET_GPIO_NUM;
  config.xclk_freq_hz = 20000000;
  config.frame_size = FRAMESIZE_VGA;   //choose the prefered size
    /*UXGA(1600x1200)
      SXGA(1280x1024)
      XGA(1024x768)
      SVGA(800x600)
      VGA(640x480)
      CIF(400x296)
      QVGA(320x240)
      HQVGA(240x176)
      QQVGA(160x120)
     */
  config.pixel_format = PIXFORMAT_JPEG; // for streaming
  config.grab_mode = CAMERA_GRAB_WHEN_EMPTY;
  config.fb_location = CAMERA_FB_IN_PSRAM;
  config.jpeg_quality = 12;
  config.fb_count = 1;
 
  // if PSRAM IC present, init with UXGA resolution and higher JPEG quality
  //                      for larger pre-allocated frame buffer.
  if(config.pixel_format == PIXFORMAT_JPEG){
    if(psramFound()){
      config.jpeg_quality = 10;
      config.fb_count = 2;
      config.grab_mode = CAMERA_GRAB_LATEST;
    } else {
      // Limit the frame size when PSRAM is not available
      config.frame_size = FRAMESIZE_CIF;
      config.fb_location = CAMERA_FB_IN_DRAM;
    }
  } else {
    // Best option for face detection/recognition
    config.frame_size = FRAMESIZE_240X240;
#if CONFIG_IDF_TARGET_ESP32S3
    config.fb_count = 2;
#endif
  }
 
 
  // Camera init
  esp_err_t err = esp_camera_init(&config);
  if (err != ESP_OK) {
    Serial.printf("Camera init failed with error 0x%x", err);
    return;
  }
  // Wi-Fi connection (Soft Access Point)
  WiFi.softAP(ssid);

/*
 // Wi-Fi connection for your network
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
*/

  Serial.println("");
  Serial.println("WiFi connected");
 
  Serial.print("Camera Stream Ready! Go to: http://");
  Serial.println(WiFi.localIP());
 
  // Start streaming web server
  startCameraServer();

}

//  servo1.attach(6); - bal elso - D5
//  servo2.attach(5); - jobb elso - D4
//  servo3.attach(44); - bal kozep - D7
//  servo4.attach(7); - jobb kozep - D8
//  servo5.attach(8); - bal hatso - D9
//  servo6.attach(9); - jobb hatso - D10
//  + oramutatoval ellentetesen
//  - oramutatoval

void loop() {
  if (flag == 1) {
    automode();
  } else {
    if (currentCommand == "forward") {
      forward();
    } else if (currentCommand == "backward") {
      backward();
    } else if (currentCommand == "left") {
      left();
    } else if (currentCommand == "right") {
      right();
    } else if (currentCommand == "turnleft") {
      turnleft();
    } else if (currentCommand == "turnright") {
      turnright();
    } else if (currentCommand == "rise") {
      rise();
    } else if (currentCommand == "stop") {
      stop();
    }
  }
}

void forward() {
    pwm.writeServo(servo3, center3 - 45);
    delay(50);
    pwm.writeServo(servo1, center1 - steplength);
    delay(20);
    pwm.writeServo(servo5, center5 - steplength);
    delay(50);
	pwm.writeServo(servo3, center3 + 32);
    delay(50);
	
	pwm.writeServo(servo4, center4 + 45);
    delay(50);
    pwm.writeServo(servo2, center2 + steplength);
    delay(20);
    pwm.writeServo(servo6, center6 + steplength);
    delay(50);
	pwm.writeServo(servo4, center4 - 32);
    delay(50);
	
	pwm.writeServo(servo1, center1);
    delay(20);
	pwm.writeServo(servo2, center2);
    delay(20);
    pwm.writeServo(servo5, center5);
    delay(20);
    pwm.writeServo(servo6, center6);
    delay(50);
	pwm.writeServo(servo3, center3);
    delay(20);
	pwm.writeServo(servo4, center4);
    delay(50);
}

void backward() {
    pwm.writeServo(servo3, center3 - 45);
    delay(50);
    pwm.writeServo(servo1, center1 + steplength);
    delay(20);
    pwm.writeServo(servo5, center5 + steplength);
    delay(50);
	pwm.writeServo(servo3, center3 + 32);
    delay(50);
	
	pwm.writeServo(servo4, center4 + 45);
    delay(50);
    pwm.writeServo(servo2, center2 - steplength);
    delay(20);
    pwm.writeServo(servo6, center6 - steplength);
    delay(50);
	pwm.writeServo(servo4, center4 - 32);
    delay(50);
	
	pwm.writeServo(servo1, center1);
    delay(20);
	pwm.writeServo(servo2, center2);
    delay(20);
    pwm.writeServo(servo5, center5);
    delay(20);
    pwm.writeServo(servo6, center6);
    delay(50);
	pwm.writeServo(servo3, center3);
    delay(20);
	pwm.writeServo(servo4, center4);
    delay(50);
}

void left() {
    pwm.writeServo(servo3, center3 - 45);
    delay(50);
    pwm.writeServo(servo1, center1 - smallstep);
    delay(20);
    pwm.writeServo(servo5, center5 - smallstep);
    delay(50);
	pwm.writeServo(servo3, center3 + 32);
    delay(50);
	
	pwm.writeServo(servo4, center4 + 45);
    delay(50);
    pwm.writeServo(servo2, center2 + steplength);
    delay(20);
    pwm.writeServo(servo6, center6 + steplength);
    delay(50);
	pwm.writeServo(servo4, center4 - 32);
    delay(50);
	
	pwm.writeServo(servo1, center1);
    delay(20);
	pwm.writeServo(servo2, center2);
    delay(20);
    pwm.writeServo(servo5, center5);
    delay(20);
    pwm.writeServo(servo6, center6);
    delay(50);
	pwm.writeServo(servo3, center3);
    delay(20);
	pwm.writeServo(servo4, center4);
    delay(50);

}

void right() {
    pwm.writeServo(servo3, center3 - 45);
    delay(50);
    pwm.writeServo(servo1, center1 - steplength);
    delay(20);
    pwm.writeServo(servo5, center5 - steplength);
    delay(50);
	pwm.writeServo(servo3, center3 + 32);
    delay(50);
	
	pwm.writeServo(servo4, center4 + 45);
    delay(50);
    pwm.writeServo(servo2, center2 + smallstep);
    delay(20);
    pwm.writeServo(servo6, center6 + smallstep);
    delay(50);
	pwm.writeServo(servo4, center4 - 32);
    delay(50);
	
	pwm.writeServo(servo1, center1);
    delay(20);
	pwm.writeServo(servo2, center2);
    delay(20);
    pwm.writeServo(servo5, center5);
    delay(20);
    pwm.writeServo(servo6, center6);
    delay(50);
	pwm.writeServo(servo3, center3);
    delay(20);
	pwm.writeServo(servo4, center4);
    delay(50);
}

void turnleft() {
    pwm.writeServo(servo3, center3 - 45);
    delay(50);
    pwm.writeServo(servo1, center1 - 1);
    delay(20);
    pwm.writeServo(servo5, center5 - 1);
    delay(50);
	pwm.writeServo(servo3, center3 + 32);
    delay(50);
	
	pwm.writeServo(servo4, center4 + 45);
    delay(50);
    pwm.writeServo(servo2, center2 + steplength);
    delay(20);
    pwm.writeServo(servo6, center6 + steplength);
    delay(50);
	pwm.writeServo(servo4, center4 - 32);
    delay(50);
	
	pwm.writeServo(servo1, center1);
    delay(20);
	pwm.writeServo(servo2, center2);
    delay(20);
    pwm.writeServo(servo5, center5);
    delay(20);
    pwm.writeServo(servo6, center6);
    delay(50);
	pwm.writeServo(servo3, center3);
    delay(20);
	pwm.writeServo(servo4, center4);
    delay(50);
}

void turnright() {
    pwm.writeServo(servo3, center3 - 45);
    delay(50);
    pwm.writeServo(servo1, center1 - steplength);
    delay(20);
    pwm.writeServo(servo5, center5 - steplength);
    delay(50);
	pwm.writeServo(servo3, center3 + 32);
    delay(50);
	
	pwm.writeServo(servo4, center4 + 45);
    delay(50);
    pwm.writeServo(servo2, center2 + 1);
    delay(20);
    pwm.writeServo(servo6, center6 + 1);
    delay(50);
	pwm.writeServo(servo4, center4 - 32);
    delay(50);
	
	pwm.writeServo(servo1, center1);
    delay(20);
	pwm.writeServo(servo2, center2);
    delay(20);
    pwm.writeServo(servo5, center5);
    delay(20);
    pwm.writeServo(servo6, center6);
    delay(50);
	pwm.writeServo(servo3, center3);
    delay(20);
	pwm.writeServo(servo4, center4);
    delay(50);
}

void stop() {
	pwm.writeServo(servo1, center1);
    delay(20);
	pwm.writeServo(servo2, center2);
    delay(20);
    pwm.writeServo(servo5, center5);
    delay(20);
    pwm.writeServo(servo6, center6);
    delay(50);
	pwm.writeServo(servo3, center3);
    delay(20);
	pwm.writeServo(servo4, center4);
    delay(50);
}

void rise() {}

void automode(){
       leftState = digitalRead(buttonLeft);
   rightState = digitalRead(buttonRight);
   delay(50);
 
   if  ((rightState == LOW) && (leftState == HIGH)) {
     Serial.println("stop and go right");
     for (int i = 0; i<=7; i++){
      backward();
     }
     for (int i = 0; i<=7; i++){
      turnright();
     }
   }
   else if  ((rightState == HIGH) && (leftState == LOW)) {
     Serial.println("stop and go left");
     for (int i = 0; i<=7; i++){
      backward();
     }
     for (int i = 0; i<=7; i++){
      turnleft();
     }     
   }
   else if  ((rightState == HIGH) && (leftState == HIGH)) {
     Serial.println("stop, go back and try again");
     for (int i = 0; i<=7; i++){
        backward();
     }
     for (int i = 0; i<=7; i++){
      turnleft();
     }  
   }  
   else {
    forward();
   }
}